%define anolis_release 1
%define pre_release pre3
%define version_num 3.2.4

Name:		rsync
Version:	%{version_num}~%{pre_release}
Release:	%{anolis_release}%{?dist}
Summary:	A program for synchronizing files over a network

License:	GPLv3+
URL:		https://github.com/WayneD/rsync
Source0:	https://github.com/WayneD/rsync/archive/refs/tags/v%{version_num}%{pre_release}.tar.gz
Source1:	https://github.com/WayneD/rsync/archive/refs/tags/%{name}-patches-%{version_num}%{pre_release}.tar.gz
Source2: 	rsyncd.socket
Source3: 	rsyncd.service
Source4: 	rsyncd.conf
Source5: 	rsyncd.sysconfig
Source6: 	rsyncd@.service

BuildRequires: 	make vim
BuildRequires: 	gcc
BuildRequires: 	gcc-c++
BuildRequires: 	libacl-devel
BuildRequires: 	libattr-devel
BuildRequires: 	autoconf automake
BuildRequires: 	popt-devel
BuildRequires: 	systemd
BuildRequires: 	lz4-devel
BuildRequires: 	openssl-devel libtool-ltdl
BuildRequires: 	libzstd-devel
BuildRequires: 	xxhash-devel
BuildRequires:	python3-cmarkgfm

#needed to make hello test run correctly
Patch0: 	0000-bugfix-test-md5-check-failure-1.patch
Patch1:		0001-bugfix-test-md5-check-failure-2.patch
Patch2: 	0002-rsync-3.2.2-runtests.patch
Patch3: 	0003-rsync-3.2.4-hello-test.patch

Patch4:		0004-cve-2018-25032.patch
Patch5:		0005-restart-daemon-on-failure.patch

%description
Rsync uses a reliable algorithm to bring remote and host files into
sync very quickly. Rsync is fast because it just sends the differences
in the files over the network instead of sending the complete
files. Rsync is often used as a very powerful mirroring process or
just as a more capable replacement for the rcp command. A technical
report which describes the rsync algorithm is included in this
package.
	
%package 	daemon
Summary: 	Service for anonymous access to rsync
BuildArch: 	noarch
Requires: 	%{name} = %{version}-%{release}
%{?systemd_requires}

%description 	daemon
Rsync can be used to offer read only access to anonymous clients. This
package provides the anonymous rsync service.

%prep
%autosetup -b 1 -n %{name}-%{version_num}%{pre_release} -p1

#Enable --copy-devices parameter
patch -p1 -i patches/copy-devices.diff

%build
%configure \
  --enable-openssl \
  --enable-xxhash \
  --enable-zstd \
  --enable-lz4 \
  --enable-ipv6

%make_build

%install
%make_install
install -D -m644 %{SOURCE2} %{buildroot}/%{_unitdir}/rsyncd.socket
install -D -m644 %{SOURCE3} %{buildroot}/%{_unitdir}/rsyncd.service
install -D -m644 %{SOURCE4} %{buildroot}/%{_sysconfdir}/rsyncd.conf
install -D -m644 %{SOURCE5} %{buildroot}/%{_sysconfdir}/sysconfig/rsyncd
install -D -m644 %{SOURCE6} %{buildroot}/%{_unitdir}/rsyncd@.service

%check
make check
chmod -x support/*

%post daemon
%systemd_post rsyncd.service
 
%preun daemon
%systemd_preun rsyncd.service
 
%postun daemon
%systemd_postun_with_restart rsyncd.service

%files
%license COPYING
%doc support/ tech_report.tex
%{_bindir}/%{name}
%{_bindir}/%{name}-ssl
%{_mandir}/man1/%{name}.1*
%{_mandir}/man1/%{name}-ssl.1*
%{_mandir}/man5/rsyncd.conf.5*
%config(noreplace) %{_sysconfdir}/rsyncd.conf

%files daemon
%config(noreplace) %{_sysconfdir}/sysconfig/rsyncd
%{_unitdir}/rsyncd.socket
%{_unitdir}/rsyncd.service
%{_unitdir}/rsyncd@.service

%changelog
* Thu Apr 14 2022 happy_orange <songnannan@linux.alibaba.com> - 3.2.4~pre3-1
- Init package from upstream
